// This file is generated by TypeBuilder_h.template.

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef content_protocol_Page_h
#define content_protocol_Page_h

#include "content/common/content_export.h"
#include "content/browser/devtools/protocol/protocol.h"
// For each imported domain we generate a ValueConversions struct instead of a full domain definition
// and include Domain::API version from there.
#include "content/browser/devtools/protocol/dom.h"
#include "content/browser/devtools/protocol/io.h"
#include "content/browser/devtools/protocol/network.h"
#include "content/browser/devtools/protocol/runtime.h"

namespace content {
namespace protocol {
namespace Page {
using FrameId = String;
using TransitionType = String;
class NavigationEntry;
class ScreencastFrameMetadata;
using DialogType = String;
class AppManifestError;
class AppManifestParsedProperties;
class Viewport;
class InstallabilityErrorArgument;
class InstallabilityError;
using ReferrerPolicy = String;
class FileFilter;
class FileHandler;
class ImageResource;
class LaunchHandler;
class ProtocolHandler;
class RelatedApplication;
class ScopeExtension;
class Screenshot;
class ShareTarget;
class Shortcut;
class WebAppManifest;
using BackForwardCacheNotRestoredReason = String;
using BackForwardCacheNotRestoredReasonType = String;
class BackForwardCacheBlockingDetails;
class BackForwardCacheNotRestoredExplanation;
class BackForwardCacheNotRestoredExplanationTree;

// ------------- Forward and enum declarations.

namespace TransitionTypeEnum {
CONTENT_EXPORT extern const char Link[];
CONTENT_EXPORT extern const char Typed[];
CONTENT_EXPORT extern const char Address_bar[];
CONTENT_EXPORT extern const char Auto_bookmark[];
CONTENT_EXPORT extern const char Auto_subframe[];
CONTENT_EXPORT extern const char Manual_subframe[];
CONTENT_EXPORT extern const char Generated[];
CONTENT_EXPORT extern const char Auto_toplevel[];
CONTENT_EXPORT extern const char Form_submit[];
CONTENT_EXPORT extern const char Reload[];
CONTENT_EXPORT extern const char Keyword[];
CONTENT_EXPORT extern const char Keyword_generated[];
CONTENT_EXPORT extern const char Other[];
} // namespace TransitionTypeEnum

namespace DialogTypeEnum {
CONTENT_EXPORT extern const char Alert[];
CONTENT_EXPORT extern const char Confirm[];
CONTENT_EXPORT extern const char Prompt[];
CONTENT_EXPORT extern const char Beforeunload[];
} // namespace DialogTypeEnum

namespace ReferrerPolicyEnum {
CONTENT_EXPORT extern const char NoReferrer[];
CONTENT_EXPORT extern const char NoReferrerWhenDowngrade[];
CONTENT_EXPORT extern const char Origin[];
CONTENT_EXPORT extern const char OriginWhenCrossOrigin[];
CONTENT_EXPORT extern const char SameOrigin[];
CONTENT_EXPORT extern const char StrictOrigin[];
CONTENT_EXPORT extern const char StrictOriginWhenCrossOrigin[];
CONTENT_EXPORT extern const char UnsafeUrl[];
} // namespace ReferrerPolicyEnum

namespace BackForwardCacheNotRestoredReasonEnum {
CONTENT_EXPORT extern const char NotPrimaryMainFrame[];
CONTENT_EXPORT extern const char BackForwardCacheDisabled[];
CONTENT_EXPORT extern const char RelatedActiveContentsExist[];
CONTENT_EXPORT extern const char HTTPStatusNotOK[];
CONTENT_EXPORT extern const char SchemeNotHTTPOrHTTPS[];
CONTENT_EXPORT extern const char Loading[];
CONTENT_EXPORT extern const char WasGrantedMediaAccess[];
CONTENT_EXPORT extern const char DisableForRenderFrameHostCalled[];
CONTENT_EXPORT extern const char DomainNotAllowed[];
CONTENT_EXPORT extern const char HTTPMethodNotGET[];
CONTENT_EXPORT extern const char SubframeIsNavigating[];
CONTENT_EXPORT extern const char Timeout[];
CONTENT_EXPORT extern const char CacheLimit[];
CONTENT_EXPORT extern const char JavaScriptExecution[];
CONTENT_EXPORT extern const char RendererProcessKilled[];
CONTENT_EXPORT extern const char RendererProcessCrashed[];
CONTENT_EXPORT extern const char SchedulerTrackedFeatureUsed[];
CONTENT_EXPORT extern const char ConflictingBrowsingInstance[];
CONTENT_EXPORT extern const char CacheFlushed[];
CONTENT_EXPORT extern const char ServiceWorkerVersionActivation[];
CONTENT_EXPORT extern const char SessionRestored[];
CONTENT_EXPORT extern const char ServiceWorkerPostMessage[];
CONTENT_EXPORT extern const char EnteredBackForwardCacheBeforeServiceWorkerHostAdded[];
CONTENT_EXPORT extern const char RenderFrameHostReused_SameSite[];
CONTENT_EXPORT extern const char RenderFrameHostReused_CrossSite[];
CONTENT_EXPORT extern const char ServiceWorkerClaim[];
CONTENT_EXPORT extern const char IgnoreEventAndEvict[];
CONTENT_EXPORT extern const char HaveInnerContents[];
CONTENT_EXPORT extern const char TimeoutPuttingInCache[];
CONTENT_EXPORT extern const char BackForwardCacheDisabledByLowMemory[];
CONTENT_EXPORT extern const char BackForwardCacheDisabledByCommandLine[];
CONTENT_EXPORT extern const char NetworkRequestDatapipeDrainedAsBytesConsumer[];
CONTENT_EXPORT extern const char NetworkRequestRedirected[];
CONTENT_EXPORT extern const char NetworkRequestTimeout[];
CONTENT_EXPORT extern const char NetworkExceedsBufferLimit[];
CONTENT_EXPORT extern const char NavigationCancelledWhileRestoring[];
CONTENT_EXPORT extern const char NotMostRecentNavigationEntry[];
CONTENT_EXPORT extern const char BackForwardCacheDisabledForPrerender[];
CONTENT_EXPORT extern const char UserAgentOverrideDiffers[];
CONTENT_EXPORT extern const char ForegroundCacheLimit[];
CONTENT_EXPORT extern const char BrowsingInstanceNotSwapped[];
CONTENT_EXPORT extern const char BackForwardCacheDisabledForDelegate[];
CONTENT_EXPORT extern const char UnloadHandlerExistsInMainFrame[];
CONTENT_EXPORT extern const char UnloadHandlerExistsInSubFrame[];
CONTENT_EXPORT extern const char ServiceWorkerUnregistration[];
CONTENT_EXPORT extern const char CacheControlNoStore[];
CONTENT_EXPORT extern const char CacheControlNoStoreCookieModified[];
CONTENT_EXPORT extern const char CacheControlNoStoreHTTPOnlyCookieModified[];
CONTENT_EXPORT extern const char NoResponseHead[];
CONTENT_EXPORT extern const char Unknown[];
CONTENT_EXPORT extern const char ActivationNavigationsDisallowedForBug1234857[];
CONTENT_EXPORT extern const char ErrorDocument[];
CONTENT_EXPORT extern const char FencedFramesEmbedder[];
CONTENT_EXPORT extern const char CookieDisabled[];
CONTENT_EXPORT extern const char HTTPAuthRequired[];
CONTENT_EXPORT extern const char CookieFlushed[];
CONTENT_EXPORT extern const char BroadcastChannelOnMessage[];
CONTENT_EXPORT extern const char WebViewSettingsChanged[];
CONTENT_EXPORT extern const char WebViewJavaScriptObjectChanged[];
CONTENT_EXPORT extern const char WebViewMessageListenerInjected[];
CONTENT_EXPORT extern const char WebViewSafeBrowsingAllowlistChanged[];
CONTENT_EXPORT extern const char WebViewDocumentStartJavascriptChanged[];
CONTENT_EXPORT extern const char WebSocket[];
CONTENT_EXPORT extern const char WebTransport[];
CONTENT_EXPORT extern const char WebRTC[];
CONTENT_EXPORT extern const char MainResourceHasCacheControlNoStore[];
CONTENT_EXPORT extern const char MainResourceHasCacheControlNoCache[];
CONTENT_EXPORT extern const char SubresourceHasCacheControlNoStore[];
CONTENT_EXPORT extern const char SubresourceHasCacheControlNoCache[];
CONTENT_EXPORT extern const char ContainsPlugins[];
CONTENT_EXPORT extern const char DocumentLoaded[];
CONTENT_EXPORT extern const char OutstandingNetworkRequestOthers[];
CONTENT_EXPORT extern const char RequestedMIDIPermission[];
CONTENT_EXPORT extern const char RequestedAudioCapturePermission[];
CONTENT_EXPORT extern const char RequestedVideoCapturePermission[];
CONTENT_EXPORT extern const char RequestedBackForwardCacheBlockedSensors[];
CONTENT_EXPORT extern const char RequestedBackgroundWorkPermission[];
CONTENT_EXPORT extern const char BroadcastChannel[];
CONTENT_EXPORT extern const char WebXR[];
CONTENT_EXPORT extern const char SharedWorker[];
CONTENT_EXPORT extern const char WebLocks[];
CONTENT_EXPORT extern const char WebHID[];
CONTENT_EXPORT extern const char WebShare[];
CONTENT_EXPORT extern const char RequestedStorageAccessGrant[];
CONTENT_EXPORT extern const char WebNfc[];
CONTENT_EXPORT extern const char OutstandingNetworkRequestFetch[];
CONTENT_EXPORT extern const char OutstandingNetworkRequestXHR[];
CONTENT_EXPORT extern const char AppBanner[];
CONTENT_EXPORT extern const char Printing[];
CONTENT_EXPORT extern const char WebDatabase[];
CONTENT_EXPORT extern const char PictureInPicture[];
CONTENT_EXPORT extern const char SpeechRecognizer[];
CONTENT_EXPORT extern const char IdleManager[];
CONTENT_EXPORT extern const char PaymentManager[];
CONTENT_EXPORT extern const char SpeechSynthesis[];
CONTENT_EXPORT extern const char KeyboardLock[];
CONTENT_EXPORT extern const char WebOTPService[];
CONTENT_EXPORT extern const char OutstandingNetworkRequestDirectSocket[];
CONTENT_EXPORT extern const char InjectedJavascript[];
CONTENT_EXPORT extern const char InjectedStyleSheet[];
CONTENT_EXPORT extern const char KeepaliveRequest[];
CONTENT_EXPORT extern const char IndexedDBEvent[];
CONTENT_EXPORT extern const char Dummy[];
CONTENT_EXPORT extern const char JsNetworkRequestReceivedCacheControlNoStoreResource[];
CONTENT_EXPORT extern const char WebRTCSticky[];
CONTENT_EXPORT extern const char WebTransportSticky[];
CONTENT_EXPORT extern const char WebSocketSticky[];
CONTENT_EXPORT extern const char SmartCard[];
CONTENT_EXPORT extern const char LiveMediaStreamTrack[];
CONTENT_EXPORT extern const char UnloadHandler[];
CONTENT_EXPORT extern const char ParserAborted[];
CONTENT_EXPORT extern const char ContentSecurityHandler[];
CONTENT_EXPORT extern const char ContentWebAuthenticationAPI[];
CONTENT_EXPORT extern const char ContentFileChooser[];
CONTENT_EXPORT extern const char ContentSerial[];
CONTENT_EXPORT extern const char ContentFileSystemAccess[];
CONTENT_EXPORT extern const char ContentMediaDevicesDispatcherHost[];
CONTENT_EXPORT extern const char ContentWebBluetooth[];
CONTENT_EXPORT extern const char ContentWebUSB[];
CONTENT_EXPORT extern const char ContentMediaSessionService[];
CONTENT_EXPORT extern const char ContentScreenReader[];
CONTENT_EXPORT extern const char ContentDiscarded[];
CONTENT_EXPORT extern const char EmbedderPopupBlockerTabHelper[];
CONTENT_EXPORT extern const char EmbedderSafeBrowsingTriggeredPopupBlocker[];
CONTENT_EXPORT extern const char EmbedderSafeBrowsingThreatDetails[];
CONTENT_EXPORT extern const char EmbedderAppBannerManager[];
CONTENT_EXPORT extern const char EmbedderDomDistillerViewerSource[];
CONTENT_EXPORT extern const char EmbedderDomDistillerSelfDeletingRequestDelegate[];
CONTENT_EXPORT extern const char EmbedderOomInterventionTabHelper[];
CONTENT_EXPORT extern const char EmbedderOfflinePage[];
CONTENT_EXPORT extern const char EmbedderChromePasswordManagerClientBindCredentialManager[];
CONTENT_EXPORT extern const char EmbedderPermissionRequestManager[];
CONTENT_EXPORT extern const char EmbedderModalDialog[];
CONTENT_EXPORT extern const char EmbedderExtensions[];
CONTENT_EXPORT extern const char EmbedderExtensionMessaging[];
CONTENT_EXPORT extern const char EmbedderExtensionMessagingForOpenPort[];
CONTENT_EXPORT extern const char EmbedderExtensionSentMessageToCachedFrame[];
CONTENT_EXPORT extern const char RequestedByWebViewClient[];
} // namespace BackForwardCacheNotRestoredReasonEnum

namespace BackForwardCacheNotRestoredReasonTypeEnum {
CONTENT_EXPORT extern const char SupportPending[];
CONTENT_EXPORT extern const char PageSupportNeeded[];
CONTENT_EXPORT extern const char Circumstantial[];
} // namespace BackForwardCacheNotRestoredReasonTypeEnum

namespace CaptureScreenshot {
namespace FormatEnum {
CONTENT_EXPORT extern const char* Jpeg;
CONTENT_EXPORT extern const char* Png;
CONTENT_EXPORT extern const char* Webp;
} // FormatEnum
} // CaptureScreenshot

namespace CaptureSnapshot {
namespace FormatEnum {
CONTENT_EXPORT extern const char* Mhtml;
} // FormatEnum
} // CaptureSnapshot

namespace PrintToPDF {
namespace TransferModeEnum {
CONTENT_EXPORT extern const char* ReturnAsBase64;
CONTENT_EXPORT extern const char* ReturnAsStream;
} // TransferModeEnum
} // PrintToPDF

namespace SetDownloadBehavior {
namespace BehaviorEnum {
CONTENT_EXPORT extern const char* Deny;
CONTENT_EXPORT extern const char* Allow;
CONTENT_EXPORT extern const char* Default;
} // BehaviorEnum
} // SetDownloadBehavior

namespace SetTouchEmulationEnabled {
namespace ConfigurationEnum {
CONTENT_EXPORT extern const char* Mobile;
CONTENT_EXPORT extern const char* Desktop;
} // ConfigurationEnum
} // SetTouchEmulationEnabled

namespace StartScreencast {
namespace FormatEnum {
CONTENT_EXPORT extern const char* Jpeg;
CONTENT_EXPORT extern const char* Png;
} // FormatEnum
} // StartScreencast

namespace SetWebLifecycleState {
namespace StateEnum {
CONTENT_EXPORT extern const char* Frozen;
CONTENT_EXPORT extern const char* Active;
} // StateEnum
} // SetWebLifecycleState

namespace FileChooserOpened {
namespace ModeEnum {
CONTENT_EXPORT extern const char* SelectSingle;
CONTENT_EXPORT extern const char* SelectMultiple;
} // ModeEnum
} // FileChooserOpened

namespace FrameDetached {
namespace ReasonEnum {
CONTENT_EXPORT extern const char* Remove;
CONTENT_EXPORT extern const char* Swap;
} // ReasonEnum
} // FrameDetached

namespace DownloadProgress {
namespace StateEnum {
CONTENT_EXPORT extern const char* InProgress;
CONTENT_EXPORT extern const char* Completed;
CONTENT_EXPORT extern const char* Canceled;
} // StateEnum
} // DownloadProgress

namespace NavigatedWithinDocument {
namespace NavigationTypeEnum {
CONTENT_EXPORT extern const char* Fragment;
CONTENT_EXPORT extern const char* HistoryApi;
CONTENT_EXPORT extern const char* Other;
} // NavigationTypeEnum
} // NavigatedWithinDocument

// ------------- Type and builder declarations.

class CONTENT_EXPORT NavigationEntry : public ::crdtp::ProtocolObject<NavigationEntry> {
public:
    ~NavigationEntry() override { }

    int GetId() { return m_id; }
    void SetId(int value) { m_id = value; }

    String GetUrl() { return m_url; }
    void SetUrl(const String& value) { m_url = value; }

    String GetUserTypedURL() { return m_userTypedURL; }
    void SetUserTypedURL(const String& value) { m_userTypedURL = value; }

    String GetTitle() { return m_title; }
    void SetTitle(const String& value) { m_title = value; }

    String GetTransitionType() { return m_transitionType; }
    void SetTransitionType(const String& value) { m_transitionType = value; }

    template<int STATE>
    class NavigationEntryBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            IdSet = 1 << 1,
            UrlSet = 1 << 2,
            UserTypedURLSet = 1 << 3,
            TitleSet = 1 << 4,
            TransitionTypeSet = 1 << 5,
            AllFieldsSet = (IdSet | UrlSet | UserTypedURLSet | TitleSet | TransitionTypeSet | 0)};


        NavigationEntryBuilder<STATE | IdSet>& SetId(int value)
        {
            static_assert(!(STATE & IdSet), "property id should not be set yet");
            m_result->SetId(value);
            return castState<IdSet>();
        }

        NavigationEntryBuilder<STATE | UrlSet>& SetUrl(const String& value)
        {
            static_assert(!(STATE & UrlSet), "property url should not be set yet");
            m_result->SetUrl(value);
            return castState<UrlSet>();
        }

        NavigationEntryBuilder<STATE | UserTypedURLSet>& SetUserTypedURL(const String& value)
        {
            static_assert(!(STATE & UserTypedURLSet), "property userTypedURL should not be set yet");
            m_result->SetUserTypedURL(value);
            return castState<UserTypedURLSet>();
        }

        NavigationEntryBuilder<STATE | TitleSet>& SetTitle(const String& value)
        {
            static_assert(!(STATE & TitleSet), "property title should not be set yet");
            m_result->SetTitle(value);
            return castState<TitleSet>();
        }

        NavigationEntryBuilder<STATE | TransitionTypeSet>& SetTransitionType(const String& value)
        {
            static_assert(!(STATE & TransitionTypeSet), "property transitionType should not be set yet");
            m_result->SetTransitionType(value);
            return castState<TransitionTypeSet>();
        }

        std::unique_ptr<NavigationEntry> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class NavigationEntry;
        NavigationEntryBuilder() : m_result(new NavigationEntry()) { }

        template<int STEP> NavigationEntryBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<NavigationEntryBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::Page::NavigationEntry> m_result;
    };

    static NavigationEntryBuilder<0> Create()
    {
        return NavigationEntryBuilder<0>();
    }

private:
    DECLARE_SERIALIZATION_SUPPORT();

    NavigationEntry()
    {
          m_id = 0;
    }

    int m_id;
    String m_url;
    String m_userTypedURL;
    String m_title;
    String m_transitionType;
};


class CONTENT_EXPORT ScreencastFrameMetadata : public ::crdtp::ProtocolObject<ScreencastFrameMetadata> {
public:
    ~ScreencastFrameMetadata() override { }

    double GetOffsetTop() { return m_offsetTop; }
    void SetOffsetTop(double value) { m_offsetTop = value; }

    double GetPageScaleFactor() { return m_pageScaleFactor; }
    void SetPageScaleFactor(double value) { m_pageScaleFactor = value; }

    double GetDeviceWidth() { return m_deviceWidth; }
    void SetDeviceWidth(double value) { m_deviceWidth = value; }

    double GetDeviceHeight() { return m_deviceHeight; }
    void SetDeviceHeight(double value) { m_deviceHeight = value; }

    double GetScrollOffsetX() { return m_scrollOffsetX; }
    void SetScrollOffsetX(double value) { m_scrollOffsetX = value; }

    double GetScrollOffsetY() { return m_scrollOffsetY; }
    void SetScrollOffsetY(double value) { m_scrollOffsetY = value; }

    bool HasTimestamp() { return m_timestamp.has_value(); }
    double GetTimestamp(double defaultValue) const {
       return m_timestamp.value_or(defaultValue);
    }
    void SetTimestamp(double value) { m_timestamp = value; }

    template<int STATE>
    class ScreencastFrameMetadataBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            OffsetTopSet = 1 << 1,
            PageScaleFactorSet = 1 << 2,
            DeviceWidthSet = 1 << 3,
            DeviceHeightSet = 1 << 4,
            ScrollOffsetXSet = 1 << 5,
            ScrollOffsetYSet = 1 << 6,
            AllFieldsSet = (OffsetTopSet | PageScaleFactorSet | DeviceWidthSet | DeviceHeightSet | ScrollOffsetXSet | ScrollOffsetYSet | 0)};


        ScreencastFrameMetadataBuilder<STATE | OffsetTopSet>& SetOffsetTop(double value)
        {
            static_assert(!(STATE & OffsetTopSet), "property offsetTop should not be set yet");
            m_result->SetOffsetTop(value);
            return castState<OffsetTopSet>();
        }

        ScreencastFrameMetadataBuilder<STATE | PageScaleFactorSet>& SetPageScaleFactor(double value)
        {
            static_assert(!(STATE & PageScaleFactorSet), "property pageScaleFactor should not be set yet");
            m_result->SetPageScaleFactor(value);
            return castState<PageScaleFactorSet>();
        }

        ScreencastFrameMetadataBuilder<STATE | DeviceWidthSet>& SetDeviceWidth(double value)
        {
            static_assert(!(STATE & DeviceWidthSet), "property deviceWidth should not be set yet");
            m_result->SetDeviceWidth(value);
            return castState<DeviceWidthSet>();
        }

        ScreencastFrameMetadataBuilder<STATE | DeviceHeightSet>& SetDeviceHeight(double value)
        {
            static_assert(!(STATE & DeviceHeightSet), "property deviceHeight should not be set yet");
            m_result->SetDeviceHeight(value);
            return castState<DeviceHeightSet>();
        }

        ScreencastFrameMetadataBuilder<STATE | ScrollOffsetXSet>& SetScrollOffsetX(double value)
        {
            static_assert(!(STATE & ScrollOffsetXSet), "property scrollOffsetX should not be set yet");
            m_result->SetScrollOffsetX(value);
            return castState<ScrollOffsetXSet>();
        }

        ScreencastFrameMetadataBuilder<STATE | ScrollOffsetYSet>& SetScrollOffsetY(double value)
        {
            static_assert(!(STATE & ScrollOffsetYSet), "property scrollOffsetY should not be set yet");
            m_result->SetScrollOffsetY(value);
            return castState<ScrollOffsetYSet>();
        }

        ScreencastFrameMetadataBuilder<STATE>& SetTimestamp(double value)
        {
            m_result->SetTimestamp(value);
            return *this;
        }

        std::unique_ptr<ScreencastFrameMetadata> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class ScreencastFrameMetadata;
        ScreencastFrameMetadataBuilder() : m_result(new ScreencastFrameMetadata()) { }

        template<int STEP> ScreencastFrameMetadataBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<ScreencastFrameMetadataBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::Page::ScreencastFrameMetadata> m_result;
    };

    static ScreencastFrameMetadataBuilder<0> Create()
    {
        return ScreencastFrameMetadataBuilder<0>();
    }

private:
    DECLARE_SERIALIZATION_SUPPORT();

    ScreencastFrameMetadata()
    {
          m_offsetTop = 0;
          m_pageScaleFactor = 0;
          m_deviceWidth = 0;
          m_deviceHeight = 0;
          m_scrollOffsetX = 0;
          m_scrollOffsetY = 0;
    }

    double m_offsetTop;
    double m_pageScaleFactor;
    double m_deviceWidth;
    double m_deviceHeight;
    double m_scrollOffsetX;
    double m_scrollOffsetY;
    Maybe<double> m_timestamp;
};


class CONTENT_EXPORT AppManifestError : public ::crdtp::ProtocolObject<AppManifestError> {
public:
    ~AppManifestError() override { }

    String GetMessage() { return m_message; }
    void SetMessage(const String& value) { m_message = value; }

    int GetCritical() { return m_critical; }
    void SetCritical(int value) { m_critical = value; }

    int GetLine() { return m_line; }
    void SetLine(int value) { m_line = value; }

    int GetColumn() { return m_column; }
    void SetColumn(int value) { m_column = value; }

    template<int STATE>
    class AppManifestErrorBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            MessageSet = 1 << 1,
            CriticalSet = 1 << 2,
            LineSet = 1 << 3,
            ColumnSet = 1 << 4,
            AllFieldsSet = (MessageSet | CriticalSet | LineSet | ColumnSet | 0)};


        AppManifestErrorBuilder<STATE | MessageSet>& SetMessage(const String& value)
        {
            static_assert(!(STATE & MessageSet), "property message should not be set yet");
            m_result->SetMessage(value);
            return castState<MessageSet>();
        }

        AppManifestErrorBuilder<STATE | CriticalSet>& SetCritical(int value)
        {
            static_assert(!(STATE & CriticalSet), "property critical should not be set yet");
            m_result->SetCritical(value);
            return castState<CriticalSet>();
        }

        AppManifestErrorBuilder<STATE | LineSet>& SetLine(int value)
        {
            static_assert(!(STATE & LineSet), "property line should not be set yet");
            m_result->SetLine(value);
            return castState<LineSet>();
        }

        AppManifestErrorBuilder<STATE | ColumnSet>& SetColumn(int value)
        {
            static_assert(!(STATE & ColumnSet), "property column should not be set yet");
            m_result->SetColumn(value);
            return castState<ColumnSet>();
        }

        std::unique_ptr<AppManifestError> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class AppManifestError;
        AppManifestErrorBuilder() : m_result(new AppManifestError()) { }

        template<int STEP> AppManifestErrorBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<AppManifestErrorBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::Page::AppManifestError> m_result;
    };

    static AppManifestErrorBuilder<0> Create()
    {
        return AppManifestErrorBuilder<0>();
    }

private:
    DECLARE_SERIALIZATION_SUPPORT();

    AppManifestError()
    {
          m_critical = 0;
          m_line = 0;
          m_column = 0;
    }

    String m_message;
    int m_critical;
    int m_line;
    int m_column;
};


class CONTENT_EXPORT AppManifestParsedProperties : public ::crdtp::ProtocolObject<AppManifestParsedProperties> {
public:
    ~AppManifestParsedProperties() override { }

    String GetScope() { return m_scope; }
    void SetScope(const String& value) { m_scope = value; }

    template<int STATE>
    class AppManifestParsedPropertiesBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            ScopeSet = 1 << 1,
            AllFieldsSet = (ScopeSet | 0)};


        AppManifestParsedPropertiesBuilder<STATE | ScopeSet>& SetScope(const String& value)
        {
            static_assert(!(STATE & ScopeSet), "property scope should not be set yet");
            m_result->SetScope(value);
            return castState<ScopeSet>();
        }

        std::unique_ptr<AppManifestParsedProperties> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class AppManifestParsedProperties;
        AppManifestParsedPropertiesBuilder() : m_result(new AppManifestParsedProperties()) { }

        template<int STEP> AppManifestParsedPropertiesBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<AppManifestParsedPropertiesBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::Page::AppManifestParsedProperties> m_result;
    };

    static AppManifestParsedPropertiesBuilder<0> Create()
    {
        return AppManifestParsedPropertiesBuilder<0>();
    }

private:
    DECLARE_SERIALIZATION_SUPPORT();

    AppManifestParsedProperties()
    {
    }

    String m_scope;
};


class CONTENT_EXPORT Viewport : public ::crdtp::ProtocolObject<Viewport> {
public:
    ~Viewport() override { }

    double GetX() { return m_x; }
    void SetX(double value) { m_x = value; }

    double GetY() { return m_y; }
    void SetY(double value) { m_y = value; }

    double GetWidth() { return m_width; }
    void SetWidth(double value) { m_width = value; }

    double GetHeight() { return m_height; }
    void SetHeight(double value) { m_height = value; }

    double GetScale() { return m_scale; }
    void SetScale(double value) { m_scale = value; }

    template<int STATE>
    class ViewportBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            XSet = 1 << 1,
            YSet = 1 << 2,
            WidthSet = 1 << 3,
            HeightSet = 1 << 4,
            ScaleSet = 1 << 5,
            AllFieldsSet = (XSet | YSet | WidthSet | HeightSet | ScaleSet | 0)};


        ViewportBuilder<STATE | XSet>& SetX(double value)
        {
            static_assert(!(STATE & XSet), "property x should not be set yet");
            m_result->SetX(value);
            return castState<XSet>();
        }

        ViewportBuilder<STATE | YSet>& SetY(double value)
        {
            static_assert(!(STATE & YSet), "property y should not be set yet");
            m_result->SetY(value);
            return castState<YSet>();
        }

        ViewportBuilder<STATE | WidthSet>& SetWidth(double value)
        {
            static_assert(!(STATE & WidthSet), "property width should not be set yet");
            m_result->SetWidth(value);
            return castState<WidthSet>();
        }

        ViewportBuilder<STATE | HeightSet>& SetHeight(double value)
        {
            static_assert(!(STATE & HeightSet), "property height should not be set yet");
            m_result->SetHeight(value);
            return castState<HeightSet>();
        }

        ViewportBuilder<STATE | ScaleSet>& SetScale(double value)
        {
            static_assert(!(STATE & ScaleSet), "property scale should not be set yet");
            m_result->SetScale(value);
            return castState<ScaleSet>();
        }

        std::unique_ptr<Viewport> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class Viewport;
        ViewportBuilder() : m_result(new Viewport()) { }

        template<int STEP> ViewportBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<ViewportBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::Page::Viewport> m_result;
    };

    static ViewportBuilder<0> Create()
    {
        return ViewportBuilder<0>();
    }

private:
    DECLARE_SERIALIZATION_SUPPORT();

    Viewport()
    {
          m_x = 0;
          m_y = 0;
          m_width = 0;
          m_height = 0;
          m_scale = 0;
    }

    double m_x;
    double m_y;
    double m_width;
    double m_height;
    double m_scale;
};


class CONTENT_EXPORT InstallabilityErrorArgument : public ::crdtp::ProtocolObject<InstallabilityErrorArgument> {
public:
    ~InstallabilityErrorArgument() override { }

    String GetName() { return m_name; }
    void SetName(const String& value) { m_name = value; }

    String GetValue() { return m_value; }
    void SetValue(const String& value) { m_value = value; }

    template<int STATE>
    class InstallabilityErrorArgumentBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            NameSet = 1 << 1,
            ValueSet = 1 << 2,
            AllFieldsSet = (NameSet | ValueSet | 0)};


        InstallabilityErrorArgumentBuilder<STATE | NameSet>& SetName(const String& value)
        {
            static_assert(!(STATE & NameSet), "property name should not be set yet");
            m_result->SetName(value);
            return castState<NameSet>();
        }

        InstallabilityErrorArgumentBuilder<STATE | ValueSet>& SetValue(const String& value)
        {
            static_assert(!(STATE & ValueSet), "property value should not be set yet");
            m_result->SetValue(value);
            return castState<ValueSet>();
        }

        std::unique_ptr<InstallabilityErrorArgument> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class InstallabilityErrorArgument;
        InstallabilityErrorArgumentBuilder() : m_result(new InstallabilityErrorArgument()) { }

        template<int STEP> InstallabilityErrorArgumentBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<InstallabilityErrorArgumentBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::Page::InstallabilityErrorArgument> m_result;
    };

    static InstallabilityErrorArgumentBuilder<0> Create()
    {
        return InstallabilityErrorArgumentBuilder<0>();
    }

private:
    DECLARE_SERIALIZATION_SUPPORT();

    InstallabilityErrorArgument()
    {
    }

    String m_name;
    String m_value;
};


class CONTENT_EXPORT InstallabilityError : public ::crdtp::ProtocolObject<InstallabilityError> {
public:
    ~InstallabilityError() override { }

    String GetErrorId() { return m_errorId; }
    void SetErrorId(const String& value) { m_errorId = value; }

    protocol::Array<protocol::Page::InstallabilityErrorArgument>* GetErrorArguments() { return m_errorArguments.get(); }
    void SetErrorArguments(std::unique_ptr<protocol::Array<protocol::Page::InstallabilityErrorArgument>> value) { m_errorArguments = std::move(value); }

    template<int STATE>
    class InstallabilityErrorBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            ErrorIdSet = 1 << 1,
            ErrorArgumentsSet = 1 << 2,
            AllFieldsSet = (ErrorIdSet | ErrorArgumentsSet | 0)};


        InstallabilityErrorBuilder<STATE | ErrorIdSet>& SetErrorId(const String& value)
        {
            static_assert(!(STATE & ErrorIdSet), "property errorId should not be set yet");
            m_result->SetErrorId(value);
            return castState<ErrorIdSet>();
        }

        InstallabilityErrorBuilder<STATE | ErrorArgumentsSet>& SetErrorArguments(std::unique_ptr<protocol::Array<protocol::Page::InstallabilityErrorArgument>> value)
        {
            static_assert(!(STATE & ErrorArgumentsSet), "property errorArguments should not be set yet");
            m_result->SetErrorArguments(std::move(value));
            return castState<ErrorArgumentsSet>();
        }

        std::unique_ptr<InstallabilityError> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class InstallabilityError;
        InstallabilityErrorBuilder() : m_result(new InstallabilityError()) { }

        template<int STEP> InstallabilityErrorBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<InstallabilityErrorBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::Page::InstallabilityError> m_result;
    };

    static InstallabilityErrorBuilder<0> Create()
    {
        return InstallabilityErrorBuilder<0>();
    }

private:
    DECLARE_SERIALIZATION_SUPPORT();

    InstallabilityError()
    {
    }

    String m_errorId;
    std::unique_ptr<protocol::Array<protocol::Page::InstallabilityErrorArgument>> m_errorArguments;
};


class CONTENT_EXPORT FileFilter : public ::crdtp::ProtocolObject<FileFilter> {
public:
    ~FileFilter() override { }

    bool HasName() { return m_name.has_value(); }
    String GetName(const String& defaultValue) const {
       return m_name.value_or(defaultValue);
    }
    void SetName(const String& value) { m_name = value; }

    bool HasAccepts() { return m_accepts.has_value(); }
    protocol::Array<String>* GetAccepts(protocol::Array<String>* defaultValue) {
       return m_accepts.has_value() ? &m_accepts.value() : defaultValue;
    }
    void SetAccepts(std::unique_ptr<protocol::Array<String>> value) { m_accepts = std::move(value); }

    template<int STATE>
    class FileFilterBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            AllFieldsSet = (0)};


        FileFilterBuilder<STATE>& SetName(const String& value)
        {
            m_result->SetName(value);
            return *this;
        }

        FileFilterBuilder<STATE>& SetAccepts(std::unique_ptr<protocol::Array<String>> value)
        {
            m_result->SetAccepts(std::move(value));
            return *this;
        }

        std::unique_ptr<FileFilter> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class FileFilter;
        FileFilterBuilder() : m_result(new FileFilter()) { }

        template<int STEP> FileFilterBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<FileFilterBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::Page::FileFilter> m_result;
    };

    static FileFilterBuilder<0> Create()
    {
        return FileFilterBuilder<0>();
    }

private:
    DECLARE_SERIALIZATION_SUPPORT();

    FileFilter()
    {
    }

    Maybe<String> m_name;
    Maybe<protocol::Array<String>> m_accepts;
};


class CONTENT_EXPORT FileHandler : public ::crdtp::ProtocolObject<FileHandler> {
public:
    ~FileHandler() override { }

    String GetAction() { return m_action; }
    void SetAction(const String& value) { m_action = value; }

    String GetName() { return m_name; }
    void SetName(const String& value) { m_name = value; }

    bool HasIcons() { return m_icons.has_value(); }
    protocol::Array<protocol::Page::ImageResource>* GetIcons(protocol::Array<protocol::Page::ImageResource>* defaultValue) {
       return m_icons.has_value() ? &m_icons.value() : defaultValue;
    }
    void SetIcons(std::unique_ptr<protocol::Array<protocol::Page::ImageResource>> value) { m_icons = std::move(value); }

    bool HasAccepts() { return m_accepts.has_value(); }
    protocol::Array<protocol::Page::FileFilter>* GetAccepts(protocol::Array<protocol::Page::FileFilter>* defaultValue) {
       return m_accepts.has_value() ? &m_accepts.value() : defaultValue;
    }
    void SetAccepts(std::unique_ptr<protocol::Array<protocol::Page::FileFilter>> value) { m_accepts = std::move(value); }

    String GetLaunchType() { return m_launchType; }
    void SetLaunchType(const String& value) { m_launchType = value; }

    template<int STATE>
    class FileHandlerBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            ActionSet = 1 << 1,
            NameSet = 1 << 2,
            LaunchTypeSet = 1 << 3,
            AllFieldsSet = (ActionSet | NameSet | LaunchTypeSet | 0)};


        FileHandlerBuilder<STATE | ActionSet>& SetAction(const String& value)
        {
            static_assert(!(STATE & ActionSet), "property action should not be set yet");
            m_result->SetAction(value);
            return castState<ActionSet>();
        }

        FileHandlerBuilder<STATE | NameSet>& SetName(const String& value)
        {
            static_assert(!(STATE & NameSet), "property name should not be set yet");
            m_result->SetName(value);
            return castState<NameSet>();
        }

        FileHandlerBuilder<STATE>& SetIcons(std::unique_ptr<protocol::Array<protocol::Page::ImageResource>> value)
        {
            m_result->SetIcons(std::move(value));
            return *this;
        }

        FileHandlerBuilder<STATE>& SetAccepts(std::unique_ptr<protocol::Array<protocol::Page::FileFilter>> value)
        {
            m_result->SetAccepts(std::move(value));
            return *this;
        }

        FileHandlerBuilder<STATE | LaunchTypeSet>& SetLaunchType(const String& value)
        {
            static_assert(!(STATE & LaunchTypeSet), "property launchType should not be set yet");
            m_result->SetLaunchType(value);
            return castState<LaunchTypeSet>();
        }

        std::unique_ptr<FileHandler> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class FileHandler;
        FileHandlerBuilder() : m_result(new FileHandler()) { }

        template<int STEP> FileHandlerBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<FileHandlerBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::Page::FileHandler> m_result;
    };

    static FileHandlerBuilder<0> Create()
    {
        return FileHandlerBuilder<0>();
    }

private:
    DECLARE_SERIALIZATION_SUPPORT();

    FileHandler()
    {
    }

    String m_action;
    String m_name;
    Maybe<protocol::Array<protocol::Page::ImageResource>> m_icons;
    Maybe<protocol::Array<protocol::Page::FileFilter>> m_accepts;
    String m_launchType;
};


class CONTENT_EXPORT ImageResource : public ::crdtp::ProtocolObject<ImageResource> {
public:
    ~ImageResource() override { }

    String GetUrl() { return m_url; }
    void SetUrl(const String& value) { m_url = value; }

    bool HasSizes() { return m_sizes.has_value(); }
    String GetSizes(const String& defaultValue) const {
       return m_sizes.value_or(defaultValue);
    }
    void SetSizes(const String& value) { m_sizes = value; }

    bool HasType() { return m_type.has_value(); }
    String GetType(const String& defaultValue) const {
       return m_type.value_or(defaultValue);
    }
    void SetType(const String& value) { m_type = value; }

    template<int STATE>
    class ImageResourceBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            UrlSet = 1 << 1,
            AllFieldsSet = (UrlSet | 0)};


        ImageResourceBuilder<STATE | UrlSet>& SetUrl(const String& value)
        {
            static_assert(!(STATE & UrlSet), "property url should not be set yet");
            m_result->SetUrl(value);
            return castState<UrlSet>();
        }

        ImageResourceBuilder<STATE>& SetSizes(const String& value)
        {
            m_result->SetSizes(value);
            return *this;
        }

        ImageResourceBuilder<STATE>& SetType(const String& value)
        {
            m_result->SetType(value);
            return *this;
        }

        std::unique_ptr<ImageResource> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class ImageResource;
        ImageResourceBuilder() : m_result(new ImageResource()) { }

        template<int STEP> ImageResourceBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<ImageResourceBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::Page::ImageResource> m_result;
    };

    static ImageResourceBuilder<0> Create()
    {
        return ImageResourceBuilder<0>();
    }

private:
    DECLARE_SERIALIZATION_SUPPORT();

    ImageResource()
    {
    }

    String m_url;
    Maybe<String> m_sizes;
    Maybe<String> m_type;
};


class CONTENT_EXPORT LaunchHandler : public ::crdtp::ProtocolObject<LaunchHandler> {
public:
    ~LaunchHandler() override { }

    String GetClientMode() { return m_clientMode; }
    void SetClientMode(const String& value) { m_clientMode = value; }

    template<int STATE>
    class LaunchHandlerBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            ClientModeSet = 1 << 1,
            AllFieldsSet = (ClientModeSet | 0)};


        LaunchHandlerBuilder<STATE | ClientModeSet>& SetClientMode(const String& value)
        {
            static_assert(!(STATE & ClientModeSet), "property clientMode should not be set yet");
            m_result->SetClientMode(value);
            return castState<ClientModeSet>();
        }

        std::unique_ptr<LaunchHandler> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class LaunchHandler;
        LaunchHandlerBuilder() : m_result(new LaunchHandler()) { }

        template<int STEP> LaunchHandlerBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<LaunchHandlerBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::Page::LaunchHandler> m_result;
    };

    static LaunchHandlerBuilder<0> Create()
    {
        return LaunchHandlerBuilder<0>();
    }

private:
    DECLARE_SERIALIZATION_SUPPORT();

    LaunchHandler()
    {
    }

    String m_clientMode;
};


class CONTENT_EXPORT ProtocolHandler : public ::crdtp::ProtocolObject<ProtocolHandler> {
public:
    ~ProtocolHandler() override { }

    String GetProtocol() { return m_protocol; }
    void SetProtocol(const String& value) { m_protocol = value; }

    String GetUrl() { return m_url; }
    void SetUrl(const String& value) { m_url = value; }

    template<int STATE>
    class ProtocolHandlerBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            ProtocolSet = 1 << 1,
            UrlSet = 1 << 2,
            AllFieldsSet = (ProtocolSet | UrlSet | 0)};


        ProtocolHandlerBuilder<STATE | ProtocolSet>& SetProtocol(const String& value)
        {
            static_assert(!(STATE & ProtocolSet), "property protocol should not be set yet");
            m_result->SetProtocol(value);
            return castState<ProtocolSet>();
        }

        ProtocolHandlerBuilder<STATE | UrlSet>& SetUrl(const String& value)
        {
            static_assert(!(STATE & UrlSet), "property url should not be set yet");
            m_result->SetUrl(value);
            return castState<UrlSet>();
        }

        std::unique_ptr<ProtocolHandler> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class ProtocolHandler;
        ProtocolHandlerBuilder() : m_result(new ProtocolHandler()) { }

        template<int STEP> ProtocolHandlerBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<ProtocolHandlerBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::Page::ProtocolHandler> m_result;
    };

    static ProtocolHandlerBuilder<0> Create()
    {
        return ProtocolHandlerBuilder<0>();
    }

private:
    DECLARE_SERIALIZATION_SUPPORT();

    ProtocolHandler()
    {
    }

    String m_protocol;
    String m_url;
};


class CONTENT_EXPORT RelatedApplication : public ::crdtp::ProtocolObject<RelatedApplication> {
public:
    ~RelatedApplication() override { }

    bool HasId() { return m_id.has_value(); }
    String GetId(const String& defaultValue) const {
       return m_id.value_or(defaultValue);
    }
    void SetId(const String& value) { m_id = value; }

    String GetUrl() { return m_url; }
    void SetUrl(const String& value) { m_url = value; }

    template<int STATE>
    class RelatedApplicationBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            UrlSet = 1 << 1,
            AllFieldsSet = (UrlSet | 0)};


        RelatedApplicationBuilder<STATE>& SetId(const String& value)
        {
            m_result->SetId(value);
            return *this;
        }

        RelatedApplicationBuilder<STATE | UrlSet>& SetUrl(const String& value)
        {
            static_assert(!(STATE & UrlSet), "property url should not be set yet");
            m_result->SetUrl(value);
            return castState<UrlSet>();
        }

        std::unique_ptr<RelatedApplication> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class RelatedApplication;
        RelatedApplicationBuilder() : m_result(new RelatedApplication()) { }

        template<int STEP> RelatedApplicationBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<RelatedApplicationBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::Page::RelatedApplication> m_result;
    };

    static RelatedApplicationBuilder<0> Create()
    {
        return RelatedApplicationBuilder<0>();
    }

private:
    DECLARE_SERIALIZATION_SUPPORT();

    RelatedApplication()
    {
    }

    Maybe<String> m_id;
    String m_url;
};


class CONTENT_EXPORT ScopeExtension : public ::crdtp::ProtocolObject<ScopeExtension> {
public:
    ~ScopeExtension() override { }

    String GetOrigin() { return m_origin; }
    void SetOrigin(const String& value) { m_origin = value; }

    bool GetHasOriginWildcard() { return m_hasOriginWildcard; }
    void SetHasOriginWildcard(bool value) { m_hasOriginWildcard = value; }

    template<int STATE>
    class ScopeExtensionBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            OriginSet = 1 << 1,
            HasOriginWildcardSet = 1 << 2,
            AllFieldsSet = (OriginSet | HasOriginWildcardSet | 0)};


        ScopeExtensionBuilder<STATE | OriginSet>& SetOrigin(const String& value)
        {
            static_assert(!(STATE & OriginSet), "property origin should not be set yet");
            m_result->SetOrigin(value);
            return castState<OriginSet>();
        }

        ScopeExtensionBuilder<STATE | HasOriginWildcardSet>& SetHasOriginWildcard(bool value)
        {
            static_assert(!(STATE & HasOriginWildcardSet), "property hasOriginWildcard should not be set yet");
            m_result->SetHasOriginWildcard(value);
            return castState<HasOriginWildcardSet>();
        }

        std::unique_ptr<ScopeExtension> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class ScopeExtension;
        ScopeExtensionBuilder() : m_result(new ScopeExtension()) { }

        template<int STEP> ScopeExtensionBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<ScopeExtensionBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::Page::ScopeExtension> m_result;
    };

    static ScopeExtensionBuilder<0> Create()
    {
        return ScopeExtensionBuilder<0>();
    }

private:
    DECLARE_SERIALIZATION_SUPPORT();

    ScopeExtension()
    {
          m_hasOriginWildcard = false;
    }

    String m_origin;
    bool m_hasOriginWildcard;
};


class CONTENT_EXPORT Screenshot : public ::crdtp::ProtocolObject<Screenshot> {
public:
    ~Screenshot() override { }

    protocol::Page::ImageResource* GetImage() { return m_image.get(); }
    void SetImage(std::unique_ptr<protocol::Page::ImageResource> value) { m_image = std::move(value); }

    String GetFormFactor() { return m_formFactor; }
    void SetFormFactor(const String& value) { m_formFactor = value; }

    bool HasLabel() { return m_label.has_value(); }
    String GetLabel(const String& defaultValue) const {
       return m_label.value_or(defaultValue);
    }
    void SetLabel(const String& value) { m_label = value; }

    template<int STATE>
    class ScreenshotBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            ImageSet = 1 << 1,
            FormFactorSet = 1 << 2,
            AllFieldsSet = (ImageSet | FormFactorSet | 0)};


        ScreenshotBuilder<STATE | ImageSet>& SetImage(std::unique_ptr<protocol::Page::ImageResource> value)
        {
            static_assert(!(STATE & ImageSet), "property image should not be set yet");
            m_result->SetImage(std::move(value));
            return castState<ImageSet>();
        }

        ScreenshotBuilder<STATE | FormFactorSet>& SetFormFactor(const String& value)
        {
            static_assert(!(STATE & FormFactorSet), "property formFactor should not be set yet");
            m_result->SetFormFactor(value);
            return castState<FormFactorSet>();
        }

        ScreenshotBuilder<STATE>& SetLabel(const String& value)
        {
            m_result->SetLabel(value);
            return *this;
        }

        std::unique_ptr<Screenshot> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class Screenshot;
        ScreenshotBuilder() : m_result(new Screenshot()) { }

        template<int STEP> ScreenshotBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<ScreenshotBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::Page::Screenshot> m_result;
    };

    static ScreenshotBuilder<0> Create()
    {
        return ScreenshotBuilder<0>();
    }

private:
    DECLARE_SERIALIZATION_SUPPORT();

    Screenshot()
    {
    }

    std::unique_ptr<protocol::Page::ImageResource> m_image;
    String m_formFactor;
    Maybe<String> m_label;
};


class CONTENT_EXPORT ShareTarget : public ::crdtp::ProtocolObject<ShareTarget> {
public:
    ~ShareTarget() override { }

    String GetAction() { return m_action; }
    void SetAction(const String& value) { m_action = value; }

    String GetMethod() { return m_method; }
    void SetMethod(const String& value) { m_method = value; }

    String GetEnctype() { return m_enctype; }
    void SetEnctype(const String& value) { m_enctype = value; }

    bool HasTitle() { return m_title.has_value(); }
    String GetTitle(const String& defaultValue) const {
       return m_title.value_or(defaultValue);
    }
    void SetTitle(const String& value) { m_title = value; }

    bool HasText() { return m_text.has_value(); }
    String GetText(const String& defaultValue) const {
       return m_text.value_or(defaultValue);
    }
    void SetText(const String& value) { m_text = value; }

    bool HasUrl() { return m_url.has_value(); }
    String GetUrl(const String& defaultValue) const {
       return m_url.value_or(defaultValue);
    }
    void SetUrl(const String& value) { m_url = value; }

    bool HasFiles() { return m_files.has_value(); }
    protocol::Array<protocol::Page::FileFilter>* GetFiles(protocol::Array<protocol::Page::FileFilter>* defaultValue) {
       return m_files.has_value() ? &m_files.value() : defaultValue;
    }
    void SetFiles(std::unique_ptr<protocol::Array<protocol::Page::FileFilter>> value) { m_files = std::move(value); }

    template<int STATE>
    class ShareTargetBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            ActionSet = 1 << 1,
            MethodSet = 1 << 2,
            EnctypeSet = 1 << 3,
            AllFieldsSet = (ActionSet | MethodSet | EnctypeSet | 0)};


        ShareTargetBuilder<STATE | ActionSet>& SetAction(const String& value)
        {
            static_assert(!(STATE & ActionSet), "property action should not be set yet");
            m_result->SetAction(value);
            return castState<ActionSet>();
        }

        ShareTargetBuilder<STATE | MethodSet>& SetMethod(const String& value)
        {
            static_assert(!(STATE & MethodSet), "property method should not be set yet");
            m_result->SetMethod(value);
            return castState<MethodSet>();
        }

        ShareTargetBuilder<STATE | EnctypeSet>& SetEnctype(const String& value)
        {
            static_assert(!(STATE & EnctypeSet), "property enctype should not be set yet");
            m_result->SetEnctype(value);
            return castState<EnctypeSet>();
        }

        ShareTargetBuilder<STATE>& SetTitle(const String& value)
        {
            m_result->SetTitle(value);
            return *this;
        }

        ShareTargetBuilder<STATE>& SetText(const String& value)
        {
            m_result->SetText(value);
            return *this;
        }

        ShareTargetBuilder<STATE>& SetUrl(const String& value)
        {
            m_result->SetUrl(value);
            return *this;
        }

        ShareTargetBuilder<STATE>& SetFiles(std::unique_ptr<protocol::Array<protocol::Page::FileFilter>> value)
        {
            m_result->SetFiles(std::move(value));
            return *this;
        }

        std::unique_ptr<ShareTarget> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class ShareTarget;
        ShareTargetBuilder() : m_result(new ShareTarget()) { }

        template<int STEP> ShareTargetBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<ShareTargetBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::Page::ShareTarget> m_result;
    };

    static ShareTargetBuilder<0> Create()
    {
        return ShareTargetBuilder<0>();
    }

private:
    DECLARE_SERIALIZATION_SUPPORT();

    ShareTarget()
    {
    }

    String m_action;
    String m_method;
    String m_enctype;
    Maybe<String> m_title;
    Maybe<String> m_text;
    Maybe<String> m_url;
    Maybe<protocol::Array<protocol::Page::FileFilter>> m_files;
};


class CONTENT_EXPORT Shortcut : public ::crdtp::ProtocolObject<Shortcut> {
public:
    ~Shortcut() override { }

    String GetName() { return m_name; }
    void SetName(const String& value) { m_name = value; }

    String GetUrl() { return m_url; }
    void SetUrl(const String& value) { m_url = value; }

    template<int STATE>
    class ShortcutBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            NameSet = 1 << 1,
            UrlSet = 1 << 2,
            AllFieldsSet = (NameSet | UrlSet | 0)};


        ShortcutBuilder<STATE | NameSet>& SetName(const String& value)
        {
            static_assert(!(STATE & NameSet), "property name should not be set yet");
            m_result->SetName(value);
            return castState<NameSet>();
        }

        ShortcutBuilder<STATE | UrlSet>& SetUrl(const String& value)
        {
            static_assert(!(STATE & UrlSet), "property url should not be set yet");
            m_result->SetUrl(value);
            return castState<UrlSet>();
        }

        std::unique_ptr<Shortcut> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class Shortcut;
        ShortcutBuilder() : m_result(new Shortcut()) { }

        template<int STEP> ShortcutBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<ShortcutBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::Page::Shortcut> m_result;
    };

    static ShortcutBuilder<0> Create()
    {
        return ShortcutBuilder<0>();
    }

private:
    DECLARE_SERIALIZATION_SUPPORT();

    Shortcut()
    {
    }

    String m_name;
    String m_url;
};


class CONTENT_EXPORT WebAppManifest : public ::crdtp::ProtocolObject<WebAppManifest> {
public:
    ~WebAppManifest() override { }

    bool HasBackgroundColor() { return m_backgroundColor.has_value(); }
    String GetBackgroundColor(const String& defaultValue) const {
       return m_backgroundColor.value_or(defaultValue);
    }
    void SetBackgroundColor(const String& value) { m_backgroundColor = value; }

    bool HasDescription() { return m_description.has_value(); }
    String GetDescription(const String& defaultValue) const {
       return m_description.value_or(defaultValue);
    }
    void SetDescription(const String& value) { m_description = value; }

    bool HasDir() { return m_dir.has_value(); }
    String GetDir(const String& defaultValue) const {
       return m_dir.value_or(defaultValue);
    }
    void SetDir(const String& value) { m_dir = value; }

    bool HasDisplay() { return m_display.has_value(); }
    String GetDisplay(const String& defaultValue) const {
       return m_display.value_or(defaultValue);
    }
    void SetDisplay(const String& value) { m_display = value; }

    bool HasDisplayOverrides() { return m_displayOverrides.has_value(); }
    protocol::Array<String>* GetDisplayOverrides(protocol::Array<String>* defaultValue) {
       return m_displayOverrides.has_value() ? &m_displayOverrides.value() : defaultValue;
    }
    void SetDisplayOverrides(std::unique_ptr<protocol::Array<String>> value) { m_displayOverrides = std::move(value); }

    bool HasFileHandlers() { return m_fileHandlers.has_value(); }
    protocol::Array<protocol::Page::FileHandler>* GetFileHandlers(protocol::Array<protocol::Page::FileHandler>* defaultValue) {
       return m_fileHandlers.has_value() ? &m_fileHandlers.value() : defaultValue;
    }
    void SetFileHandlers(std::unique_ptr<protocol::Array<protocol::Page::FileHandler>> value) { m_fileHandlers = std::move(value); }

    bool HasIcons() { return m_icons.has_value(); }
    protocol::Array<protocol::Page::ImageResource>* GetIcons(protocol::Array<protocol::Page::ImageResource>* defaultValue) {
       return m_icons.has_value() ? &m_icons.value() : defaultValue;
    }
    void SetIcons(std::unique_ptr<protocol::Array<protocol::Page::ImageResource>> value) { m_icons = std::move(value); }

    bool HasId() { return m_id.has_value(); }
    String GetId(const String& defaultValue) const {
       return m_id.value_or(defaultValue);
    }
    void SetId(const String& value) { m_id = value; }

    bool HasLang() { return m_lang.has_value(); }
    String GetLang(const String& defaultValue) const {
       return m_lang.value_or(defaultValue);
    }
    void SetLang(const String& value) { m_lang = value; }

    bool HasLaunchHandler() { return m_launchHandler.has_value(); }
    protocol::Page::LaunchHandler* GetLaunchHandler(protocol::Page::LaunchHandler* defaultValue) {
       return m_launchHandler.has_value() ? &m_launchHandler.value() : defaultValue;
    }
    void SetLaunchHandler(std::unique_ptr<protocol::Page::LaunchHandler> value) { m_launchHandler = std::move(value); }

    bool HasName() { return m_name.has_value(); }
    String GetName(const String& defaultValue) const {
       return m_name.value_or(defaultValue);
    }
    void SetName(const String& value) { m_name = value; }

    bool HasOrientation() { return m_orientation.has_value(); }
    String GetOrientation(const String& defaultValue) const {
       return m_orientation.value_or(defaultValue);
    }
    void SetOrientation(const String& value) { m_orientation = value; }

    bool HasPreferRelatedApplications() { return m_preferRelatedApplications.has_value(); }
    bool GetPreferRelatedApplications(bool defaultValue) const {
       return m_preferRelatedApplications.value_or(defaultValue);
    }
    void SetPreferRelatedApplications(bool value) { m_preferRelatedApplications = value; }

    bool HasProtocolHandlers() { return m_protocolHandlers.has_value(); }
    protocol::Array<protocol::Page::ProtocolHandler>* GetProtocolHandlers(protocol::Array<protocol::Page::ProtocolHandler>* defaultValue) {
       return m_protocolHandlers.has_value() ? &m_protocolHandlers.value() : defaultValue;
    }
    void SetProtocolHandlers(std::unique_ptr<protocol::Array<protocol::Page::ProtocolHandler>> value) { m_protocolHandlers = std::move(value); }

    bool HasRelatedApplications() { return m_relatedApplications.has_value(); }
    protocol::Array<protocol::Page::RelatedApplication>* GetRelatedApplications(protocol::Array<protocol::Page::RelatedApplication>* defaultValue) {
       return m_relatedApplications.has_value() ? &m_relatedApplications.value() : defaultValue;
    }
    void SetRelatedApplications(std::unique_ptr<protocol::Array<protocol::Page::RelatedApplication>> value) { m_relatedApplications = std::move(value); }

    bool HasScope() { return m_scope.has_value(); }
    String GetScope(const String& defaultValue) const {
       return m_scope.value_or(defaultValue);
    }
    void SetScope(const String& value) { m_scope = value; }

    bool HasScopeExtensions() { return m_scopeExtensions.has_value(); }
    protocol::Array<protocol::Page::ScopeExtension>* GetScopeExtensions(protocol::Array<protocol::Page::ScopeExtension>* defaultValue) {
       return m_scopeExtensions.has_value() ? &m_scopeExtensions.value() : defaultValue;
    }
    void SetScopeExtensions(std::unique_ptr<protocol::Array<protocol::Page::ScopeExtension>> value) { m_scopeExtensions = std::move(value); }

    bool HasScreenshots() { return m_screenshots.has_value(); }
    protocol::Array<protocol::Page::Screenshot>* GetScreenshots(protocol::Array<protocol::Page::Screenshot>* defaultValue) {
       return m_screenshots.has_value() ? &m_screenshots.value() : defaultValue;
    }
    void SetScreenshots(std::unique_ptr<protocol::Array<protocol::Page::Screenshot>> value) { m_screenshots = std::move(value); }

    bool HasShareTarget() { return m_shareTarget.has_value(); }
    protocol::Page::ShareTarget* GetShareTarget(protocol::Page::ShareTarget* defaultValue) {
       return m_shareTarget.has_value() ? &m_shareTarget.value() : defaultValue;
    }
    void SetShareTarget(std::unique_ptr<protocol::Page::ShareTarget> value) { m_shareTarget = std::move(value); }

    bool HasShortName() { return m_shortName.has_value(); }
    String GetShortName(const String& defaultValue) const {
       return m_shortName.value_or(defaultValue);
    }
    void SetShortName(const String& value) { m_shortName = value; }

    bool HasShortcuts() { return m_shortcuts.has_value(); }
    protocol::Array<protocol::Page::Shortcut>* GetShortcuts(protocol::Array<protocol::Page::Shortcut>* defaultValue) {
       return m_shortcuts.has_value() ? &m_shortcuts.value() : defaultValue;
    }
    void SetShortcuts(std::unique_ptr<protocol::Array<protocol::Page::Shortcut>> value) { m_shortcuts = std::move(value); }

    bool HasStartUrl() { return m_startUrl.has_value(); }
    String GetStartUrl(const String& defaultValue) const {
       return m_startUrl.value_or(defaultValue);
    }
    void SetStartUrl(const String& value) { m_startUrl = value; }

    bool HasThemeColor() { return m_themeColor.has_value(); }
    String GetThemeColor(const String& defaultValue) const {
       return m_themeColor.value_or(defaultValue);
    }
    void SetThemeColor(const String& value) { m_themeColor = value; }

    template<int STATE>
    class WebAppManifestBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            AllFieldsSet = (0)};


        WebAppManifestBuilder<STATE>& SetBackgroundColor(const String& value)
        {
            m_result->SetBackgroundColor(value);
            return *this;
        }

        WebAppManifestBuilder<STATE>& SetDescription(const String& value)
        {
            m_result->SetDescription(value);
            return *this;
        }

        WebAppManifestBuilder<STATE>& SetDir(const String& value)
        {
            m_result->SetDir(value);
            return *this;
        }

        WebAppManifestBuilder<STATE>& SetDisplay(const String& value)
        {
            m_result->SetDisplay(value);
            return *this;
        }

        WebAppManifestBuilder<STATE>& SetDisplayOverrides(std::unique_ptr<protocol::Array<String>> value)
        {
            m_result->SetDisplayOverrides(std::move(value));
            return *this;
        }

        WebAppManifestBuilder<STATE>& SetFileHandlers(std::unique_ptr<protocol::Array<protocol::Page::FileHandler>> value)
        {
            m_result->SetFileHandlers(std::move(value));
            return *this;
        }

        WebAppManifestBuilder<STATE>& SetIcons(std::unique_ptr<protocol::Array<protocol::Page::ImageResource>> value)
        {
            m_result->SetIcons(std::move(value));
            return *this;
        }

        WebAppManifestBuilder<STATE>& SetId(const String& value)
        {
            m_result->SetId(value);
            return *this;
        }

        WebAppManifestBuilder<STATE>& SetLang(const String& value)
        {
            m_result->SetLang(value);
            return *this;
        }

        WebAppManifestBuilder<STATE>& SetLaunchHandler(std::unique_ptr<protocol::Page::LaunchHandler> value)
        {
            m_result->SetLaunchHandler(std::move(value));
            return *this;
        }

        WebAppManifestBuilder<STATE>& SetName(const String& value)
        {
            m_result->SetName(value);
            return *this;
        }

        WebAppManifestBuilder<STATE>& SetOrientation(const String& value)
        {
            m_result->SetOrientation(value);
            return *this;
        }

        WebAppManifestBuilder<STATE>& SetPreferRelatedApplications(bool value)
        {
            m_result->SetPreferRelatedApplications(value);
            return *this;
        }

        WebAppManifestBuilder<STATE>& SetProtocolHandlers(std::unique_ptr<protocol::Array<protocol::Page::ProtocolHandler>> value)
        {
            m_result->SetProtocolHandlers(std::move(value));
            return *this;
        }

        WebAppManifestBuilder<STATE>& SetRelatedApplications(std::unique_ptr<protocol::Array<protocol::Page::RelatedApplication>> value)
        {
            m_result->SetRelatedApplications(std::move(value));
            return *this;
        }

        WebAppManifestBuilder<STATE>& SetScope(const String& value)
        {
            m_result->SetScope(value);
            return *this;
        }

        WebAppManifestBuilder<STATE>& SetScopeExtensions(std::unique_ptr<protocol::Array<protocol::Page::ScopeExtension>> value)
        {
            m_result->SetScopeExtensions(std::move(value));
            return *this;
        }

        WebAppManifestBuilder<STATE>& SetScreenshots(std::unique_ptr<protocol::Array<protocol::Page::Screenshot>> value)
        {
            m_result->SetScreenshots(std::move(value));
            return *this;
        }

        WebAppManifestBuilder<STATE>& SetShareTarget(std::unique_ptr<protocol::Page::ShareTarget> value)
        {
            m_result->SetShareTarget(std::move(value));
            return *this;
        }

        WebAppManifestBuilder<STATE>& SetShortName(const String& value)
        {
            m_result->SetShortName(value);
            return *this;
        }

        WebAppManifestBuilder<STATE>& SetShortcuts(std::unique_ptr<protocol::Array<protocol::Page::Shortcut>> value)
        {
            m_result->SetShortcuts(std::move(value));
            return *this;
        }

        WebAppManifestBuilder<STATE>& SetStartUrl(const String& value)
        {
            m_result->SetStartUrl(value);
            return *this;
        }

        WebAppManifestBuilder<STATE>& SetThemeColor(const String& value)
        {
            m_result->SetThemeColor(value);
            return *this;
        }

        std::unique_ptr<WebAppManifest> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class WebAppManifest;
        WebAppManifestBuilder() : m_result(new WebAppManifest()) { }

        template<int STEP> WebAppManifestBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<WebAppManifestBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::Page::WebAppManifest> m_result;
    };

    static WebAppManifestBuilder<0> Create()
    {
        return WebAppManifestBuilder<0>();
    }

private:
    DECLARE_SERIALIZATION_SUPPORT();

    WebAppManifest()
    {
    }

    Maybe<String> m_backgroundColor;
    Maybe<String> m_description;
    Maybe<String> m_dir;
    Maybe<String> m_display;
    Maybe<protocol::Array<String>> m_displayOverrides;
    Maybe<protocol::Array<protocol::Page::FileHandler>> m_fileHandlers;
    Maybe<protocol::Array<protocol::Page::ImageResource>> m_icons;
    Maybe<String> m_id;
    Maybe<String> m_lang;
    Maybe<protocol::Page::LaunchHandler> m_launchHandler;
    Maybe<String> m_name;
    Maybe<String> m_orientation;
    Maybe<bool> m_preferRelatedApplications;
    Maybe<protocol::Array<protocol::Page::ProtocolHandler>> m_protocolHandlers;
    Maybe<protocol::Array<protocol::Page::RelatedApplication>> m_relatedApplications;
    Maybe<String> m_scope;
    Maybe<protocol::Array<protocol::Page::ScopeExtension>> m_scopeExtensions;
    Maybe<protocol::Array<protocol::Page::Screenshot>> m_screenshots;
    Maybe<protocol::Page::ShareTarget> m_shareTarget;
    Maybe<String> m_shortName;
    Maybe<protocol::Array<protocol::Page::Shortcut>> m_shortcuts;
    Maybe<String> m_startUrl;
    Maybe<String> m_themeColor;
};


class CONTENT_EXPORT BackForwardCacheBlockingDetails : public ::crdtp::ProtocolObject<BackForwardCacheBlockingDetails> {
public:
    ~BackForwardCacheBlockingDetails() override { }

    bool HasUrl() { return m_url.has_value(); }
    String GetUrl(const String& defaultValue) const {
       return m_url.value_or(defaultValue);
    }
    void SetUrl(const String& value) { m_url = value; }

    bool HasFunction() { return m_function.has_value(); }
    String GetFunction(const String& defaultValue) const {
       return m_function.value_or(defaultValue);
    }
    void SetFunction(const String& value) { m_function = value; }

    int GetLineNumber() { return m_lineNumber; }
    void SetLineNumber(int value) { m_lineNumber = value; }

    int GetColumnNumber() { return m_columnNumber; }
    void SetColumnNumber(int value) { m_columnNumber = value; }

    template<int STATE>
    class BackForwardCacheBlockingDetailsBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            LineNumberSet = 1 << 1,
            ColumnNumberSet = 1 << 2,
            AllFieldsSet = (LineNumberSet | ColumnNumberSet | 0)};


        BackForwardCacheBlockingDetailsBuilder<STATE>& SetUrl(const String& value)
        {
            m_result->SetUrl(value);
            return *this;
        }

        BackForwardCacheBlockingDetailsBuilder<STATE>& SetFunction(const String& value)
        {
            m_result->SetFunction(value);
            return *this;
        }

        BackForwardCacheBlockingDetailsBuilder<STATE | LineNumberSet>& SetLineNumber(int value)
        {
            static_assert(!(STATE & LineNumberSet), "property lineNumber should not be set yet");
            m_result->SetLineNumber(value);
            return castState<LineNumberSet>();
        }

        BackForwardCacheBlockingDetailsBuilder<STATE | ColumnNumberSet>& SetColumnNumber(int value)
        {
            static_assert(!(STATE & ColumnNumberSet), "property columnNumber should not be set yet");
            m_result->SetColumnNumber(value);
            return castState<ColumnNumberSet>();
        }

        std::unique_ptr<BackForwardCacheBlockingDetails> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class BackForwardCacheBlockingDetails;
        BackForwardCacheBlockingDetailsBuilder() : m_result(new BackForwardCacheBlockingDetails()) { }

        template<int STEP> BackForwardCacheBlockingDetailsBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<BackForwardCacheBlockingDetailsBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::Page::BackForwardCacheBlockingDetails> m_result;
    };

    static BackForwardCacheBlockingDetailsBuilder<0> Create()
    {
        return BackForwardCacheBlockingDetailsBuilder<0>();
    }

private:
    DECLARE_SERIALIZATION_SUPPORT();

    BackForwardCacheBlockingDetails()
    {
          m_lineNumber = 0;
          m_columnNumber = 0;
    }

    Maybe<String> m_url;
    Maybe<String> m_function;
    int m_lineNumber;
    int m_columnNumber;
};


class CONTENT_EXPORT BackForwardCacheNotRestoredExplanation : public ::crdtp::ProtocolObject<BackForwardCacheNotRestoredExplanation> {
public:
    ~BackForwardCacheNotRestoredExplanation() override { }

    String GetType() { return m_type; }
    void SetType(const String& value) { m_type = value; }

    String GetReason() { return m_reason; }
    void SetReason(const String& value) { m_reason = value; }

    bool HasContext() { return m_context.has_value(); }
    String GetContext(const String& defaultValue) const {
       return m_context.value_or(defaultValue);
    }
    void SetContext(const String& value) { m_context = value; }

    bool HasDetails() { return m_details.has_value(); }
    protocol::Array<protocol::Page::BackForwardCacheBlockingDetails>* GetDetails(protocol::Array<protocol::Page::BackForwardCacheBlockingDetails>* defaultValue) {
       return m_details.has_value() ? &m_details.value() : defaultValue;
    }
    void SetDetails(std::unique_ptr<protocol::Array<protocol::Page::BackForwardCacheBlockingDetails>> value) { m_details = std::move(value); }

    template<int STATE>
    class BackForwardCacheNotRestoredExplanationBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            TypeSet = 1 << 1,
            ReasonSet = 1 << 2,
            AllFieldsSet = (TypeSet | ReasonSet | 0)};


        BackForwardCacheNotRestoredExplanationBuilder<STATE | TypeSet>& SetType(const String& value)
        {
            static_assert(!(STATE & TypeSet), "property type should not be set yet");
            m_result->SetType(value);
            return castState<TypeSet>();
        }

        BackForwardCacheNotRestoredExplanationBuilder<STATE | ReasonSet>& SetReason(const String& value)
        {
            static_assert(!(STATE & ReasonSet), "property reason should not be set yet");
            m_result->SetReason(value);
            return castState<ReasonSet>();
        }

        BackForwardCacheNotRestoredExplanationBuilder<STATE>& SetContext(const String& value)
        {
            m_result->SetContext(value);
            return *this;
        }

        BackForwardCacheNotRestoredExplanationBuilder<STATE>& SetDetails(std::unique_ptr<protocol::Array<protocol::Page::BackForwardCacheBlockingDetails>> value)
        {
            m_result->SetDetails(std::move(value));
            return *this;
        }

        std::unique_ptr<BackForwardCacheNotRestoredExplanation> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class BackForwardCacheNotRestoredExplanation;
        BackForwardCacheNotRestoredExplanationBuilder() : m_result(new BackForwardCacheNotRestoredExplanation()) { }

        template<int STEP> BackForwardCacheNotRestoredExplanationBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<BackForwardCacheNotRestoredExplanationBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::Page::BackForwardCacheNotRestoredExplanation> m_result;
    };

    static BackForwardCacheNotRestoredExplanationBuilder<0> Create()
    {
        return BackForwardCacheNotRestoredExplanationBuilder<0>();
    }

private:
    DECLARE_SERIALIZATION_SUPPORT();

    BackForwardCacheNotRestoredExplanation()
    {
    }

    String m_type;
    String m_reason;
    Maybe<String> m_context;
    Maybe<protocol::Array<protocol::Page::BackForwardCacheBlockingDetails>> m_details;
};


class CONTENT_EXPORT BackForwardCacheNotRestoredExplanationTree : public ::crdtp::ProtocolObject<BackForwardCacheNotRestoredExplanationTree> {
public:
    ~BackForwardCacheNotRestoredExplanationTree() override { }

    String GetUrl() { return m_url; }
    void SetUrl(const String& value) { m_url = value; }

    protocol::Array<protocol::Page::BackForwardCacheNotRestoredExplanation>* GetExplanations() { return m_explanations.get(); }
    void SetExplanations(std::unique_ptr<protocol::Array<protocol::Page::BackForwardCacheNotRestoredExplanation>> value) { m_explanations = std::move(value); }

    protocol::Array<protocol::Page::BackForwardCacheNotRestoredExplanationTree>* GetChildren() { return m_children.get(); }
    void SetChildren(std::unique_ptr<protocol::Array<protocol::Page::BackForwardCacheNotRestoredExplanationTree>> value) { m_children = std::move(value); }

    template<int STATE>
    class BackForwardCacheNotRestoredExplanationTreeBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            UrlSet = 1 << 1,
            ExplanationsSet = 1 << 2,
            ChildrenSet = 1 << 3,
            AllFieldsSet = (UrlSet | ExplanationsSet | ChildrenSet | 0)};


        BackForwardCacheNotRestoredExplanationTreeBuilder<STATE | UrlSet>& SetUrl(const String& value)
        {
            static_assert(!(STATE & UrlSet), "property url should not be set yet");
            m_result->SetUrl(value);
            return castState<UrlSet>();
        }

        BackForwardCacheNotRestoredExplanationTreeBuilder<STATE | ExplanationsSet>& SetExplanations(std::unique_ptr<protocol::Array<protocol::Page::BackForwardCacheNotRestoredExplanation>> value)
        {
            static_assert(!(STATE & ExplanationsSet), "property explanations should not be set yet");
            m_result->SetExplanations(std::move(value));
            return castState<ExplanationsSet>();
        }

        BackForwardCacheNotRestoredExplanationTreeBuilder<STATE | ChildrenSet>& SetChildren(std::unique_ptr<protocol::Array<protocol::Page::BackForwardCacheNotRestoredExplanationTree>> value)
        {
            static_assert(!(STATE & ChildrenSet), "property children should not be set yet");
            m_result->SetChildren(std::move(value));
            return castState<ChildrenSet>();
        }

        std::unique_ptr<BackForwardCacheNotRestoredExplanationTree> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class BackForwardCacheNotRestoredExplanationTree;
        BackForwardCacheNotRestoredExplanationTreeBuilder() : m_result(new BackForwardCacheNotRestoredExplanationTree()) { }

        template<int STEP> BackForwardCacheNotRestoredExplanationTreeBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<BackForwardCacheNotRestoredExplanationTreeBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::Page::BackForwardCacheNotRestoredExplanationTree> m_result;
    };

    static BackForwardCacheNotRestoredExplanationTreeBuilder<0> Create()
    {
        return BackForwardCacheNotRestoredExplanationTreeBuilder<0>();
    }

private:
    DECLARE_SERIALIZATION_SUPPORT();

    BackForwardCacheNotRestoredExplanationTree()
    {
    }

    String m_url;
    std::unique_ptr<protocol::Array<protocol::Page::BackForwardCacheNotRestoredExplanation>> m_explanations;
    std::unique_ptr<protocol::Array<protocol::Page::BackForwardCacheNotRestoredExplanationTree>> m_children;
};


// ------------- Backend interface.

class CONTENT_EXPORT Backend {
public:
    virtual ~Backend() { }

    virtual DispatchResponse BringToFront() = 0;
    class CONTENT_EXPORT CaptureScreenshotCallback {
    public:
        virtual void sendSuccess(const Binary& data) = 0;
        virtual void sendFailure(const DispatchResponse&) = 0;
        virtual void fallThrough() = 0;
        virtual ~CaptureScreenshotCallback() { }
    };
    virtual void CaptureScreenshot(Maybe<String> in_format, Maybe<int> in_quality, Maybe<protocol::Page::Viewport> in_clip, Maybe<bool> in_fromSurface, Maybe<bool> in_captureBeyondViewport, Maybe<bool> in_optimizeForSpeed, std::unique_ptr<CaptureScreenshotCallback> callback) = 0;
    class CONTENT_EXPORT CaptureSnapshotCallback {
    public:
        virtual void sendSuccess(const String& data) = 0;
        virtual void sendFailure(const DispatchResponse&) = 0;
        virtual void fallThrough() = 0;
        virtual ~CaptureSnapshotCallback() { }
    };
    virtual void CaptureSnapshot(Maybe<String> in_format, std::unique_ptr<CaptureSnapshotCallback> callback) = 0;
    virtual DispatchResponse Disable() = 0;
    virtual DispatchResponse Enable() = 0;
    class CONTENT_EXPORT GetAppManifestCallback {
    public:
        virtual void sendSuccess(const String& url, std::unique_ptr<protocol::Array<protocol::Page::AppManifestError>> errors, Maybe<String> data, Maybe<protocol::Page::AppManifestParsedProperties> parsed, std::unique_ptr<protocol::Page::WebAppManifest> manifest) = 0;
        virtual void sendFailure(const DispatchResponse&) = 0;
        virtual void fallThrough() = 0;
        virtual ~GetAppManifestCallback() { }
    };
    virtual void GetAppManifest(Maybe<String> in_manifestId, std::unique_ptr<GetAppManifestCallback> callback) = 0;
    class CONTENT_EXPORT GetInstallabilityErrorsCallback {
    public:
        virtual void sendSuccess(std::unique_ptr<protocol::Array<protocol::Page::InstallabilityError>> installabilityErrors) = 0;
        virtual void sendFailure(const DispatchResponse&) = 0;
        virtual void fallThrough() = 0;
        virtual ~GetInstallabilityErrorsCallback() { }
    };
    virtual void GetInstallabilityErrors(std::unique_ptr<GetInstallabilityErrorsCallback> callback) = 0;
    class CONTENT_EXPORT GetManifestIconsCallback {
    public:
        virtual void sendSuccess(Maybe<Binary> primaryIcon) = 0;
        virtual void sendFailure(const DispatchResponse&) = 0;
        virtual void fallThrough() = 0;
        virtual ~GetManifestIconsCallback() { }
    };
    virtual void GetManifestIcons(std::unique_ptr<GetManifestIconsCallback> callback) = 0;
    class CONTENT_EXPORT GetAppIdCallback {
    public:
        virtual void sendSuccess(Maybe<String> appId, Maybe<String> recommendedId) = 0;
        virtual void sendFailure(const DispatchResponse&) = 0;
        virtual void fallThrough() = 0;
        virtual ~GetAppIdCallback() { }
    };
    virtual void GetAppId(std::unique_ptr<GetAppIdCallback> callback) = 0;
    virtual DispatchResponse GetNavigationHistory(int* out_currentIndex, std::unique_ptr<protocol::Array<protocol::Page::NavigationEntry>>* out_entries) = 0;
    virtual DispatchResponse ResetNavigationHistory() = 0;
    virtual DispatchResponse HandleJavaScriptDialog(bool in_accept, Maybe<String> in_promptText) = 0;
    class CONTENT_EXPORT NavigateCallback {
    public:
        virtual void sendSuccess(const String& frameId, Maybe<String> loaderId, Maybe<String> errorText) = 0;
        virtual void sendFailure(const DispatchResponse&) = 0;
        virtual void fallThrough() = 0;
        virtual ~NavigateCallback() { }
    };
    virtual void Navigate(const String& in_url, Maybe<String> in_referrer, Maybe<String> in_transitionType, Maybe<String> in_frameId, Maybe<String> in_referrerPolicy, std::unique_ptr<NavigateCallback> callback) = 0;
    virtual DispatchResponse NavigateToHistoryEntry(int in_entryId) = 0;
    class CONTENT_EXPORT ReloadCallback {
    public:
        virtual void sendSuccess() = 0;
        virtual void sendFailure(const DispatchResponse&) = 0;
        virtual void fallThrough() = 0;
        virtual ~ReloadCallback() { }
    };
    virtual void Reload(Maybe<bool> in_ignoreCache, Maybe<String> in_scriptToEvaluateOnLoad, Maybe<String> in_loaderId, std::unique_ptr<ReloadCallback> callback) = 0;
    virtual DispatchResponse ScreencastFrameAck(int in_sessionId) = 0;
    virtual DispatchResponse SetBypassCSP(bool in_enabled) = 0;
    virtual DispatchResponse SetDownloadBehavior(const String& in_behavior, Maybe<String> in_downloadPath) = 0;
    virtual DispatchResponse StartScreencast(Maybe<String> in_format, Maybe<int> in_quality, Maybe<int> in_maxWidth, Maybe<int> in_maxHeight, Maybe<int> in_everyNthFrame) = 0;
    virtual DispatchResponse StopLoading() = 0;
    virtual DispatchResponse Crash() = 0;
    virtual DispatchResponse Close() = 0;
    virtual DispatchResponse SetWebLifecycleState(const String& in_state) = 0;
    virtual DispatchResponse StopScreencast() = 0;
    virtual DispatchResponse AddCompilationCache(const String& in_url, const Binary& in_data) = 0;
    virtual DispatchResponse SetPrerenderingAllowed(bool in_isAllowed) = 0;

};

// ------------- Frontend interface.

class CONTENT_EXPORT Frontend {
public:
  explicit Frontend(FrontendChannel* frontend_channel) : frontend_channel_(frontend_channel) {}
    void FrameDetached(const String& frameId, const String& reason);
    void FrameStartedLoading(const String& frameId);
    void FrameStoppedLoading(const String& frameId);
    void DownloadWillBegin(const String& frameId, const String& guid, const String& url, const String& suggestedFilename);
    void DownloadProgress(const String& guid, double totalBytes, double receivedBytes, const String& state);
    void InterstitialHidden();
    void InterstitialShown();
    void JavascriptDialogClosed(bool result, const String& userInput);
    void JavascriptDialogOpening(const String& url, const String& message, const String& type, bool hasBrowserHandler, Maybe<String> defaultPrompt = Maybe<String>());
    void BackForwardCacheNotUsed(const String& loaderId, const String& frameId, std::unique_ptr<protocol::Array<protocol::Page::BackForwardCacheNotRestoredExplanation>> notRestoredExplanations, Maybe<protocol::Page::BackForwardCacheNotRestoredExplanationTree> notRestoredExplanationsTree = Maybe<protocol::Page::BackForwardCacheNotRestoredExplanationTree>());
    void ScreencastFrame(const Binary& data, std::unique_ptr<protocol::Page::ScreencastFrameMetadata> metadata, int sessionId);
    void ScreencastVisibilityChanged(bool visible);

  void flush();
  void sendRawNotification(std::unique_ptr<Serializable>);
 private:
  FrontendChannel* frontend_channel_;
};

// ------------- Dispatcher.

class CONTENT_EXPORT Dispatcher {
public:
    static void wire(UberDispatcher*, Backend*);

private:
    Dispatcher() { }
};

// ------------- Metainfo.

class CONTENT_EXPORT Metainfo {
public:
    using BackendClass = Backend;
    using FrontendClass = Frontend;
    using DispatcherClass = Dispatcher;
    static const char domainName[];
    static const char commandPrefix[];
    static const char version[];
};

} // namespace Page
} // namespace content
} // namespace protocol

#endif // !defined(content_protocol_Page_h)
