// third_party/blink/public/mojom/manifest/manifest_launch_handler.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_MANIFEST_MANIFEST_LAUNCH_HANDLER_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_MANIFEST_MANIFEST_LAUNCH_HANDLER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/manifest/manifest_launch_handler.mojom-shared-internal.h"



#include "base/component_export.h"




namespace blink::mojom {
class ManifestLaunchHandlerDataView;



}  // blink::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::ManifestLaunchHandlerDataView> {
  using Data = ::blink::mojom::internal::ManifestLaunchHandler_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace blink::mojom {


enum class ManifestLaunchHandler_ClientMode : int32_t {
  
  kAuto = 0,
  
  kNavigateNew = 1,
  
  kNavigateExisting = 2,
  
  kFocusExisting = 3,
  kMinValue = 0,
  kMaxValue = 3,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, ManifestLaunchHandler_ClientMode value);
inline bool IsKnownEnumValue(ManifestLaunchHandler_ClientMode value) {
  return internal::ManifestLaunchHandler_ClientMode_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


class ManifestLaunchHandlerDataView {
 public:
  ManifestLaunchHandlerDataView() = default;

  ManifestLaunchHandlerDataView(
      internal::ManifestLaunchHandler_Data* data,
      mojo::Message* message)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  [[nodiscard]] bool ReadClientMode(UserType* output) const {
    auto data_value = data_->client_mode;
    return mojo::internal::Deserialize<::blink::mojom::ManifestLaunchHandler_ClientMode>(
        data_value, output);
  }
  ManifestLaunchHandler_ClientMode client_mode() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::blink::mojom::ManifestLaunchHandler_ClientMode>(data_->client_mode));
  }
 private:
  internal::ManifestLaunchHandler_Data* data_ = nullptr;
};


}  // blink::mojom

namespace std {

template <>
struct hash<::blink::mojom::ManifestLaunchHandler_ClientMode>
    : public mojo::internal::EnumHashImpl<::blink::mojom::ManifestLaunchHandler_ClientMode> {};

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::ManifestLaunchHandler_ClientMode, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::ManifestLaunchHandler_ClientMode, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::ManifestLaunchHandler_ClientMode>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::ManifestLaunchHandlerDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::ManifestLaunchHandlerDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::ManifestLaunchHandler_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    mojo::internal::Serialize<::blink::mojom::ManifestLaunchHandler_ClientMode>(
        Traits::client_mode(input), &fragment->client_mode);
  }

  static bool Deserialize(::blink::mojom::internal::ManifestLaunchHandler_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::ManifestLaunchHandlerDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink::mojom {




}  // blink::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::ManifestLaunchHandler_ClientMode> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::blink::mojom::ManifestLaunchHandler_ClientMode value);
};

} // namespace perfetto

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_MANIFEST_MANIFEST_LAUNCH_HANDLER_MOJOM_SHARED_H_